/* Lirc Infra Red Controller Plugin
        Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
        code from gtuner lirc plugin
        cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "lirc.h"
#include "lirc_image.h"

static GtkWidget *dialog = 0,*button,*label;

void about_close_cb(GtkWidget *w,gpointer data)
{
	gtk_widget_destroy(dialog);
}

void about(void)
{
    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;
	
    if (!dialog)
    {
	dialog=gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog),
		"About LIRC Infra Red Controller plugin " VERSION);
	gtk_signal_connect(GTK_OBJECT(dialog),"destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed),&dialog);

	gtk_widget_realize(dialog);

	pixmap = gdk_pixmap_create_from_xpm_d (dialog->window,&mask,
					     &style->bg[GTK_STATE_NORMAL],
					     (gchar **) lirc_image);
	pixmapwid = gtk_pixmap_new (pixmap, mask);

	gtk_widget_show (pixmapwid);

	gtk_container_border_width(GTK_CONTAINER(dialog),5);
	gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),
				pixmapwid, TRUE, TRUE, 0);

	label=gtk_label_new(
"LIRC Infra RED Controller plugin "VERSION"\n\
A simple plugin that lets you control\n\
gtuner using the LIRC remote control daemon\n\n\
(C) Copyright Carl van Schaik 1998-1999\n\
E-mail <carl@leg.uct.ac.za>\n\
You can get LIRC information at:\n\
http://fsinfo.cs.uni-sb.de/~columbus/lirc/index.html"
);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,TRUE,TRUE,0);
      	gtk_widget_show(label);
	
	button=gtk_button_new_with_label(" Close ");
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(about_close_cb),NULL);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),button,FALSE,FALSE,0);
      	gtk_widget_show (button);
	
	gtk_widget_show(dialog);
	gtk_widget_grab_focus(button);
    }
}
