/* Lirc Infra Red Controller Plugin
        Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
        code from gtuner lirc plugin
        cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "lirc.h"
#include <time.h>
#include <x11amp/x11ampctrl.h>

int get_code_val(char *code, char *remote)
{
    GList *tl = lirc_codes;
    struct lirc_code *tc;

    if (code && remote)
    while (tl != NULL)
    {
	tc = tl->data;
	if (tc)
	if ((strcasecmp(tc->code, code)==0) &&
		(strcasecmp(tc->remote, remote))==0)
	    return tc->action;
	tl = g_list_next(tl);
    }

    return -1;
}

gint capture=0;
static gboolean in_use = FALSE;
void got_remote(char *new_code, char *new_remote);
static gint timer=0;
static int num=0;

gint lirc_timeout(gpointer data)
{
    plugin_set_channel(num);
    timer = 0;
    return FALSE;
}

void lirc_handle_code(int repeat, char*code, char *remote)
{
    gint code_val;
    gint vol=0;

    if (in_use) return;
    if (!code) return;
    in_use = TRUE;

    if (capture)
    {
	got_remote(code, remote);
	in_use = FALSE;
	return;
    }

    code_val = get_code_val(code, remote);
    if (code_val == -1) { in_use = FALSE; return; }

    if (repeat)
    {
	switch (code_val)
	{
	case 11:
		vol = plugin_get_volume();
		plugin_set_volume(++vol);
		break;
	case 12:
		vol = plugin_get_volume();
		plugin_set_volume(--vol);
		break;
	}
    }
    else
    {
	if (code_val < 11)
	{
	    if (timer)
	    {
		num *= 10;
		if (code_val == 10)
		    num *= 10;
		else
		    num += code_val;
		gtk_timeout_remove(timer);
		timer = gtk_timeout_add(1000, lirc_timeout, NULL);
	    }
	    else
	    {
		num = code_val;
		timer = gtk_timeout_add(1000, lirc_timeout, NULL);
	    }
	}
	else
	switch (code_val)
	{
	case 11:
		vol = plugin_get_volume();
		plugin_set_volume(++vol);
		break;
	case 12:
		vol = plugin_get_volume();
		plugin_set_volume(--vol);
		break;
	case 13:
		plugin_set_alarm_state(!plugin_get_alarm_state());
		break;
	case 14:
		plugin_set_timer(!plugin_get_timer_state());
		break;
	case 15:
		plugin_set_stereo(!plugin_is_stereo());
		break;
	case 16:
		plugin_toggle_mute();
		break;
	case 17:
		plugin_scan(-1);
		break;
	case 18:
		plugin_scan(1);
		break;
	case 19:
		plugin_channel_up();
		break;
	case 20:
		plugin_channel_down();
		break;
	case 21:
		plugin_quit_program();
		break;
	}
    }
    in_use = FALSE;
}
