/* Lirc Infra Red Controller Plugin
        Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
        code from gtuner lirc plugin
        cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <pthread.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>

#include <glib.h>
#include <gtk/gtk.h>

#include "plugins.h"

#define VERSION "0.1"

void reset(void);
void cleanup(void);
void about(void);

struct lirc_code
{
    char *function;
    char *code;
    char *remote;
    int action;
};

struct lirc_packet
{
    gint packet_type;
    gint status;
    char *message;
    GList *data;
};

extern GList *lirc_codes;
extern gchar *device;
extern gint capture;

void lirc_handle_code(int, char*, char*);
void load_config();
void configure();
struct lirc_packet *get_next_packet();
void reset_packets();
void done_with_packet();
GenericPlugin lirc_plugin;
void send_command (char *msg);

static char *code_list[] = {
"zero",         /* action 0 */
"one",          /* action 1 */
"two",
"three",
"four",
"five",
"six",
"seven",
"eight",
"nine",
"ten",
"Volume_Up",
"Volume_Down",
"Toggle_Alarm",
"Toggle_Timer",
"Toggle_Stereo",
"Toggle_mute",
"Scan_Left",
"Scan_Right",
"Channel_UP",
"Channel_Down",
"Exit"
};
static int num_codes = 22;

enum reciver_state {
        R_BEGIN=0,
        R_DATA,
        R_END,
        R_ERROR,
        R_SUCCESS,
        R_SIGHUP,
        R_STATUS,
        R_NEXT,
        R_N,
        R_NONE,
};
