/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <gtk/gtk.h>

extern int v4l_device;
extern char *v4l_card_name;
static GtkWidget *dialog = 0, *button, *label;

static void about_close_cb(GtkWidget *w,gpointer data)
{
    gtk_widget_destroy(dialog);
}

void about()
{
    if (!dialog)
    {
	char *text;
	dialog = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog), "About Video 4 Linux Card");
	gtk_signal_connect(GTK_OBJECT(dialog),"destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed),&dialog);

	if (v4l_device != -1)
	{
	    text = g_strconcat("Video 4 Linux Plugin\n"
			    "(c) 1999 Carl van Schaik\n\n"
			    "Current device = ", v4l_card_name, NULL);
	    label = gtk_label_new(text);
	    free(text);
	}
	else
	    label = gtk_label_new("Video 4 Linux Plugin\n"
			    "(c) 1999 Carl van Schaik\n\n"
			    "Not active");
	gtk_container_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), 5);

	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,TRUE,TRUE,0);
	gtk_widget_show(label);

	button=gtk_button_new_with_label(" Close ");
	gtk_signal_connect(GTK_OBJECT(button),"clicked",
			GTK_SIGNAL_FUNC(about_close_cb),NULL);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
			button,FALSE,FALSE,0);
	gtk_widget_show (button);

	gtk_widget_show(dialog);
	gtk_widget_grab_focus(button);
    }
}

