/* gtuner
        Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
        cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef KERNEL_H
#define KERNEL_H

#include "plugins.h"

radioError kernel_init (int port);
void about ();
void configure ();
void cleanup ();
void kernel_on  ();
void kernel_off ();
void kernel_mute ();
void kernel_unmute ();
void kernel_inc_volume ();
void kernel_dec_volume ();
void kernel_set_volume (int);
int  kernel_get_volume ();
void kernel_set_frequency  (double);
double kernel_get_frequency ();
void kernel_tune_up ();
void kernel_tune_down ();
void kernel_set_stereo (gboolean);
gboolean  kernel_is_tuned ();
gboolean  kernel_is_stereo ();
double kernel_get_frequency_step ();
double kernel_get_max_frequency ();
double kernel_get_min_frequency ();

static double get_freq_fact (int fd);

#endif
