/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef ALARM_H
#define ALARM_H

#include <glib.h>

/* Defines for day_bitmask */
#define SUN 1
#define MON 2
#define TUE 4
#define WED 8
#define THR 16
#define FRI 32
#define SAT 64
#define WEEK 127

struct alarm {
    gboolean active;	/* The alarm's state */
    int hour[7];	/* The set hour */
    int minute[7];	/* The set minute */
    int station[7];     /* The station to turn on */
    char day_bitmask;	/* The day of the week bitmask */
};

struct radio_config;
void initialize_alarm(struct radio_config *conf);
void activate_alarm(struct radio_config *conf);
void deactivate_alarm(struct radio_config *conf);

#endif /* ALARM_H */
