/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "channel.h"
#include <malloc.h>
#include <glib.h>

/* Create a new channel structure */
struct channel *new_channel(double freq, char *name, int num)
{
    struct channel *chan = malloc(sizeof(struct channel));

    chan->frequency = freq;
    chan->name = malloc(strlen(name)+1);
    chan->number = num;
    strcpy(chan->name, name);
    chan->next = NULL;
    chan->prev = NULL;

    return chan;
}

/* Return the n'th channel in the linked list from "first" */
struct channel *get_channel(struct channel *first, int n)
{
    int i;
    struct channel *temp = first;

    if (temp)
    for (i = 0; i < n; i++)
    {
	if (temp->next) temp = temp->next;
	else
            return NULL; /* return NULL if the channel does not exist */
    }
    return temp;
}

/* Removes a channel from the linked list */
void remove_channel(struct channel *chan)
{
    if (chan)
    {
	if ((chan->prev)&&(chan->next)) /* Middle of a list */
	{
	   chan->prev->next = chan->next;
	   chan->next->prev = chan->prev;
	}
	else
	if (chan->prev)	/* End of the list */
	{
	   chan->prev->next = NULL;
	}
	else
	if (chan->next)	/* Start of list */
	{
	   chan->next->prev = NULL;
	}

	if (chan->name)
	    free(chan->name);
	free(chan);
    }
}

/* Inserts a channel into a a linked list after channel "chan" */
void insert_channel(struct channel *chan, struct channel *new)
{
    if (chan)
    {
	if (!new) return;
    	new->next = chan->next;
	new->prev = chan;
	chan->next = new;
    }
}

