/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* config.h */
#ifndef CONFIG_H
#define CONFIG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "channel.h"
#include "alarm.h"
#include "sleep.h"
#include <glib.h>
#include <gtk/gtk.h>

typedef enum {
	PANEL_STYLE_OFF,
	PANEL_STYLE_NONE,
	PANEL_STYLE_TEXT,
	PANEL_STYLE_CHAN_BUTS,
	PANEL_STYLE_THEMED
} PanelStyle;

/* Pixmaps */
struct pixmap_config {
    GPtrArray *path;
    GPtrArray *saved_lines;
    GdkPixmap *icon_xpm;
    GdkBitmap *icon_mask;
    GdkPixmap *up_arrow_xpm;
    GdkBitmap *up_arrow_mask;
    GdkPixmap *down_arrow_xpm;
    GdkBitmap *down_arrow_mask;
    GdkPixmap *left_arrow_xpm;
    GdkBitmap *left_arrow_mask;
    GdkPixmap *right_arrow_xpm;
    GdkBitmap *right_arrow_mask;
    GdkPixmap *mute_xpm;
    GdkBitmap *mute_mask;
    GdkPixmap *unmute_xpm;
    GdkBitmap *unmute_mask;
    GdkPixmap *on_xpm;
    GdkBitmap *on_mask;
    GdkPixmap *off_xpm;
    GdkBitmap *off_mask;
    GdkPixmap *power_xpm;
    GdkBitmap *power_mask;
    GdkPixmap *scan_left_xpm;
    GdkBitmap *scan_left_mask;
    GdkPixmap *scan_right_xpm;
    GdkBitmap *scan_right_mask;
    GdkPixmap *tune_left_xpm;
    GdkBitmap *tune_left_mask;
    GdkPixmap *tune_right_xpm;
    GdkBitmap *tune_right_mask;
    GdkPixmap *plus_xpm;
    GdkBitmap *plus_mask;
    GdkPixmap *minus_xpm;
    GdkBitmap *minus_mask;
    GdkPixmap *stereo_xpm;
    GdkBitmap *stereo_mask;
};

/* Configuration options */
struct radio_config {
    int card_port;
    char *card_name;	/* card plugin shared object */
    int def_channel;	/* default channel */
    int def_volume;	/* default volume */
    gboolean set_volume;	/* set volume on startup */
    gboolean set_channel;	/* set channel on startup */
    gboolean timer_on;		/* activate sleep timer on startup */
    gboolean alarm_on;		/* activate alarm on startup */
    gboolean verbose_messages;
    gboolean off_on_exit;
    gboolean load_plugins;
    gboolean save_on_exit;
#ifdef USE_PANEL
    gboolean start_hidden;
#endif
    GList *plugin_load_list;
    int num_channels;
    struct channel *first_channel;	/* first channel in linked list */
    char *file_name;	/* configfile filename */
    char *layout_file;
    struct pixmap_config pix;
    struct alarm alarm;
    struct sleep_timer sleep;
    int fft_style;
    int quit_mute;	/* When quit (mute/leave/ask) */
    PanelStyle panel_applet_style;  /* Panel applet style */
    gchar *applet_skin_path;	    /* Path to skin's directory */
};

struct radio_card;
extern struct radio_config *read_config();
extern void save_config(struct radio_config *);

#endif /* CONFIG_H */
