/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*  This configfile code stolen from the x11amp project
 *  x11amp - graphically mp3 player..
 *  Copyright (C) 1998-1999  Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
*/
#ifndef CONFIGFILE_H
#define CONFIGFILE_H

#include <glib.h>

typedef struct
{
	gchar	*key;
	gchar	*value;
} ConfigLine;

typedef struct
{
	gchar	*name;
	GList	*lines;
} ConfigSection;
	

typedef struct
{
	GList	*sections;
} ConfigFile;

ConfigFile *gtuner_cfg_new(void);
ConfigFile *gtuner_cfg_open_file(gchar *filename);
gboolean gtuner_cfg_write_file(ConfigFile *cfg,gchar *filename);
void gtuner_cfg_free(ConfigFile *cfg);

gboolean gtuner_cfg_read_string(ConfigFile *cfg,gchar *section,gchar *key,gchar **value);
gboolean gtuner_cfg_read_int(ConfigFile *cfg,gchar *section,gchar *key,gint *value);
gboolean gtuner_cfg_read_boolean(ConfigFile *cfg,gchar *section,gchar *key,gboolean *value);
gboolean gtuner_cfg_read_float(ConfigFile *cfg,gchar *section,gchar *key,gfloat *value);
gboolean gtuner_cfg_read_double(ConfigFile *cfg,gchar *section,gchar *key,gdouble *value);

void gtuner_cfg_write_string(ConfigFile *cfg,gchar *section,gchar *key,gchar *value);
void gtuner_cfg_write_int(ConfigFile *cfg,gchar *section,gchar *key,gint value);
void gtuner_cfg_write_boolean(ConfigFile *cfg,gchar *section,gchar *key,gboolean value);
void gtuner_cfg_write_float(ConfigFile *cfg,gchar *section,gchar *key,gfloat value);
void gtuner_cfg_write_double(ConfigFile *cfg,gchar *section,gchar *key,gdouble value);

void gtuner_cfg_remove_key(ConfigFile *cfg,gchar *section,gchar *key);

#endif
