/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "gui.h"
#include "../callbacks.h"
#include <stdio.h>

static void channel_button_refresh (struct channel_object* obj, struct channel * chan);

void channel_button_new (struct channel_object *obj,
			 struct channel *first_chan)
{
    struct channel_button_data *data;
    struct channel *chan;

    data = obj->data.channel;
    chan = get_channel(first_chan, data->channel_num);

    if (chan)
    {
	data->button = new_channel_button(data->but_width, data->but_height,
		data->show_numbers, chan->number , data->show_text, chan->name);
    }
    else
    {
	data->button = new_channel_button(data->but_width, data->but_height,
		data->show_numbers, data->channel_num , data->show_text, "---");
	gtk_widget_set_sensitive(data->button->base, FALSE);
    }

    obj->base = data->button->base;
    obj->refresh = channel_button_refresh;
    data->button->signal = 0;
}

static
void channel_button_refresh (struct channel_object* obj, struct channel * first)
{
    struct channel_button_data *data;
    struct channel_button *data_but;
    struct channel *chan;
    char str[64];

    g_return_if_fail(obj != NULL);
    g_return_if_fail(obj->data.channel != NULL);
    data = obj->data.channel;
    g_return_if_fail(data != NULL);
    data_but = data->button;
    g_return_if_fail(data_but != NULL);

    chan = get_channel(first, obj->data.channel->channel_num);
    sprintf(str, "%i", obj->data.channel->channel_num);
    if (chan)
    {
	gtk_label_set(GTK_LABEL(data_but->label), chan->name);
	gtk_label_set(GTK_LABEL(data_but->number), str );
	gtk_widget_set_sensitive(data_but->base, TRUE);

	if (data_but->signal) gtk_signal_disconnect(GTK_OBJECT(data_but->base),
						data_but->signal);
	data_but->signal = gtk_signal_connect(GTK_OBJECT(data_but->base),
			"clicked", (GtkSignalFunc)
			callback_set_channel, chan);
    }
    else
    {
	gtk_label_set(GTK_LABEL(data_but->label), "---");
	gtk_label_set(GTK_LABEL(data_but->number), str);
	gtk_widget_set_sensitive(data_but->base, FALSE);
    }
}
