/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define FRAME "#888888"
#define EMPTY "#555555"
#define USED1 "#EECC66"
#define USED2 "#FF4444"
#define USED3 "#44FF44"
#define USED4 "#55FFFF"


/* XPM */
static char * pix_empty[] = {
"4 4 4 1",
"       c None",
"+      c "EMPTY,
".      c "FRAME,
"#      c #FFFFFF",
"....",
".+++",
".+++",
".+++"};

/* XPM */
static char * pix_used_1[] = {
"4 4 4 1",
"       c None",
"+      c "USED1,
".      c "FRAME,
"#      c #FFFFFF",
"....",
".+++",
".+++",
".+++"};

/* XPM */
static char * pix_used_2[] = {
"4 4 4 1",
"       c None",
"+      c "USED2,
".      c "FRAME,
"#      c #FFFFFF",
"....",
".+++",
".+++",
".+++"};

/* XPM */
static char * pix_used_3[] = {
"4 4 4 1",
"       c None",
"+      c "USED3,
".      c "FRAME,
"#      c #FFFFFF",
"....",
".+++",
".+++",
".+++"};

/* XPM */
static char * pix_used_4[] = {
"4 4 4 1",
"       c None",
"+      c "USED4,
".      c "FRAME,
"#      c #FFFFFF",
"....",
".+++",
".+++",
".+++"};

/* XPM */
static char * pix_top_left[] = {
"2 2 2 1",
"       c None",
".      c #EEEEEE",
"..",
".."};

/* XPM */
static char * pix_left[] = {
"2 4 2 1",
"       c None",
".      c #EEEEEE",
"..",
"..",
"..",
".."};

/* XPM */
static char * pix_top[] = {
"4 2 2 1",
"       c None",
".      c #EEEEEE",
"....",
"...."};

/* XPM */
static char * pix_bot_right[] = {
"3 3 2 1",
"       c None",
".      c #888888",
"...",
"...",
"..."};

/* XPM */
static char * pix_right[] = {
"3 4 2 1",
"       c None",
".      c #888888",
"...",
"...",
"...",
"..."};

/* XPM */
static char * pix_bottom[] = {
"4 3 2 1",
"       c None",
".      c #888888",
"....",
"....",
"...."};

/* XPM */
static char * pix_top_right[] = {
"3 2 3 1",
"       c None",
".      c #EEEEEE",
"+	c #888888",
"..+",
".++"};

/* XPM */
static char * pix_bot_left[] = {
"2 3 3 1",
"       c None",
"+      c #888888",
".	c #EEEEEE",
"..",
".+",
"++"};

static char * char_1[] = {
"..#..
.##..
..#..
..#..
.###."
};

static char * char_2[] = {
".##..
#..#.
..#..
.#...
####."
};

static char * char_3[] = {
".##..
#..#.
..##.
#..#.
.##.."
};

static char * char_4[] = {
"#.#..
#.#..
####.
..#..
..#.."
};

static char * char_5[] = {
"####.
#....
###..
...#.
###.."
};

static char * char_6[] = {
".##..
#....
###..
#..#.
.##.."
};

static char * char_7[] = {
"####.
...#.
...#.
...#.
...#."
};

static char * char_8[] = {
".##..
#..#.
.##..
#..#.
.##.."
};

static char * char_9[] = {
".##..
#..#.
.###.
...#.
.##.."
};

static char * char_0[] = {
".##..
##.#.
#..#.
#.##.
.##.."
};

static char * char_space[] = {
".....
.....
.....
.....
....."
};

static char * char_A[] = {
".##..
#..#.
####.
#..#.
#..#."
};

static char * char_B[] = {
"###..
#..#.
###..
#..#.
###.."
};

static char * char_C[] = {
".##..
#..#.
#....
#..#.
.##.."
};

static char * char_D[] = {
"###..
#..#.
#..#.
#..#.
###.."
};

static char * char_E[] = {
"####.
#....
###..
#....
####."
};

static char * char_F[] = {
"####.
#....
###..
#....
#...."
};

static char * char_G[] = {
".##..
#....
#.##.
#..#.
.##.."
};

static char * char_H[] = {
"#..#.
#..#.
####.
#..#.
#..#."
};

static char * char_I[] = {
".###.
..#..
..#..
..#..
.###."
};

static char * char_J[] = {
".###.
..#..
..#..
#.#..
.#..."
};

static char * char_K[] = {
"#..#.
#.#..
##...
#.#..
#..#."
};

static char * char_L[] = {
"#....
#....
#....
#....
####."
};

static char * char_M[] = {
"#..#.
####.
#..#.
#..#.
#..#."
};

static char * char_N[] = {
"#..#.
##.#.
####.
#.##.
#..#."
};

static char * char_O[] = {
".##..
#..#.
#..#.
#..#.
.##.."
};

static char * char_P[] = {
"###..
#..#.
###..
#....
#...."
};

static char * char_Q[] = {
".##..
#..#.
#..#.
#.##.
.###."
};

static char * char_R[] = {
"###..
#..#.
###..
#..#.
#..#."
};

static char * char_S[] = {
".##..
#....
.##..
...#.
.##.."
};

static char * char_T[] = {
"###..
.#...
.#...
.#...
.#..."
};

static char * char_U[] = {
"#..#.
#..#.
#..#.
#..#.
.###."
};

static char * char_V[] = {
"#..#.
#..#.
#..#.
#..#.
.##.."
};

static char * char_W[] = {
"#..#.
#..#.
#..#.
####.
.##.."
};

static char * char_X[] = {
"#..#.
#..#.
.##..
#..#.
#..#."
};

static char * char_Y[] = {
"#..#.
#..#.
.###.
..#..
..#.."
};

static char * char_Z[] = {
"####.
...#.
..#..
.#...
####."
};


static char * char_minus[] = {
".....
.....
.###.
.....
....."
};

static char * char_plus[] = {
".....
..#..
.###.
..#..
....."
};

static char * char_eq[] = {
".....
####.
.....
####.
....."
};

static char * char__[] = {
".....
.....
.....
.....
####."
};

static char * char_pipe[] = {
"..#..
..#..
..#..
..#..
..#.."
};

static char * char_bs[] = {
"#....
.#...
..#..
...#.
....#"
};

static char * char_slash[] = {
"....#
...#.
..#..
.#...
#...."
};

static char * char_star[] = {
".....
.#.#.
..#..
.#.#.
....."
};

static char * char_ob[] = {
"..#..
.#...
.#...
.#...
..#.."
};

static char * char_cb[] = {
"..#..
...#.
...#.
...#.
..#.."
};

static char * char_osb[] = {
".###.
.#...
.#...
.#...
.###."
};

static char * char_csb[] = {
".###.
...#.
...#.
...#.
.###."
};

static char * char_ocb[] = {
"..#..
.#...
.##..
.#...
..#.."
};

static char * char_ccb[] = {
"..#..
...#.
..##.
...#.
..#.."
};

static char * char_and[] = {
".#...
#.#..
.##..
#.#..
.###."
};

static char * char_hat[] = {
"..#..
.#.#.
.....
.....
....."
};

static char * char_per[] = {
".....
#..#.
..#..
.#...
#..#."
};

static char * char_hash[] = {
".#.#.
####.
.#.#.
####.
.#.#."
};

static char * char_dol[] = {
".##..
#.##.
.##..
##.#.
.##.."
};

static char * char_at[] = {
".###.
#..#.
#.##.
#....
.###."
};

static char * char_not[] = {
"..#..
..#..
..#..
.....
..#.."
};

static char * char_tilde[] = {
".#.#.
#.#..
.....
.....
....."
};

static char * char_quote[] = {
".#.#.
.#.#.
.....
.....
....."
};

static char * char_apos[] = {
"..##.
..#..
.....
.....
....."
};

static char * char_bpos[] = {
".##..
..#..
.....
.....
....."
};

static char * char_col[] = {
".....
..#..
.....
..#..
....."
};

static char * char_scol[] = {
".....
..#..
.....
..#..
.#..."
};

static char * char_ques[] = {
".##..
#..#.
..#..
.....
..#.."
};

static char * char_left[] = {
"...#.
..#..
.#...
..#..
...#."
};

static char * char_right[] = {
".#...
..#..
...#.
..#..
.#..."
};

static char * char_dot[] = {
".....
.....
.....
.##..
.##.."
};

static char * char_comma[] = {
".....
.....
.....
.##..
..#.."
};

static char * icon_mhz[] = {
"#..#.......
####.#.....
#..#.###.##
#..#.#.#.##"
};

static char * icon_mute[] = {
"#.#.#.#.###.###
###.#.#..#..##.
#.#.###..#..###"
};

static char * icon_tuned[] = {
"###
.#.
.#."
};

static char * icon_stereo[] = {
"##...##
.##.##.
.##.##.
##...##"
};

static char * icon_vol[] = {
"..............##..............##
#...#.##..#...#................#
.#.#.#..#.#...#................#
..#...##..###.##..............##"
};

