/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "gui.h"
#include "../callbacks.h"
#include <malloc.h>

extern struct radio_config *config;
extern void callback_set_stereo(GtkWidget *, gboolean);

GtkWidget *quit_button_new()
{
    GtkWidget *but;
    GtkWidget *cont;
    GtkWidget *label;

    but = gtk_button_new();
    cont = gtk_hbox_new(0, FALSE);
    gtk_container_add(GTK_CONTAINER(but), cont);

    if (!config->pix.power_xpm)
	label = gtk_label_new("quit");
    else
	label = gtk_pixmap_new( config->pix.power_xpm,
			config->pix.power_mask);

    gtk_container_add(GTK_CONTAINER(cont), label);

    gtk_signal_connect(GTK_OBJECT(but), "clicked",
		(GtkSignalFunc) gtk_main_quit, NULL);

    gtk_widget_show(but);
    gtk_widget_show(cont);
    gtk_widget_show(label);
    return but;
}

static
void mute_callback (GtkWidget *window, char *ignore)
{
    if (GTK_TOGGLE_BUTTON(window)->active) callback_mute(window, NULL);
    else callback_unmute(window, NULL);
}

static
void mute_toggle_set_state (struct mute_button *mute, gboolean state)
{
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mute->but), state);
}

struct mute_button *mute_button_new()
{
    GtkWidget *but;
    GtkWidget *cont;
    GtkWidget *label;
    struct mute_button *mute;

    but = gtk_toggle_button_new();
    cont = gtk_hbox_new(0, FALSE);
    gtk_container_add(GTK_CONTAINER(but), cont);

    label = gtk_label_new("mute");
    gtk_container_add(GTK_CONTAINER(cont), label);

    gtk_signal_connect(GTK_OBJECT(but), "toggled",
                (GtkSignalFunc) mute_callback, NULL);

    gtk_widget_show(but);
    gtk_widget_show(cont);
    gtk_widget_show(label);

    mute = malloc(sizeof(struct mute_button));
    mute->base = but;
    mute->but = but;
    mute->set_state = mute_toggle_set_state;
    return mute;
}

struct mute_button *mute_checkbutton_new()
{
    GtkWidget *but;
    struct mute_button *mute;

    but = gtk_check_button_new_with_label("mute");
    gtk_widget_show(but);

    gtk_signal_connect(GTK_OBJECT(but), "toggled",
                (GtkSignalFunc) mute_callback, NULL);

    mute = malloc(sizeof(struct mute_button));
    mute->base = but;
    mute->but = but;
    mute->set_state = mute_toggle_set_state;
    return mute;
}

static
void stereo_button_callback (GtkWidget *window, char *ignore)
{
    if (GTK_TOGGLE_BUTTON(window)->active) callback_set_stereo(window, TRUE);
    else callback_set_stereo(window, FALSE);
}

static
void stereo_toggle_set_state (struct stereo_button *stereo, gboolean state)
{
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stereo->base), state);
}

struct stereo_button *stereo_button_new()
{
    GtkWidget *but;
    GtkWidget *cont;
    GtkWidget *label;
    struct stereo_button *stereo;

    but = gtk_toggle_button_new();
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(but), TRUE);

    cont = gtk_hbox_new(0, FALSE);
    gtk_container_add(GTK_CONTAINER(but), cont);

    if (!config->pix.stereo_xpm)
        label = gtk_label_new("stereo");
    else
        label = gtk_pixmap_new( config->pix.stereo_xpm,
                        config->pix.stereo_mask);

    gtk_container_add(GTK_CONTAINER(cont), label);

    gtk_signal_connect(GTK_OBJECT(but), "toggled",
                (GtkSignalFunc) stereo_button_callback, NULL);

    gtk_widget_show(but);
    gtk_widget_show(cont);
    gtk_widget_show(label);

    stereo = malloc(sizeof(struct stereo_button));
    stereo->base = but;
    stereo->set_state = stereo_toggle_set_state;
    return stereo;
}

struct stereo_button *stereo_checkbutton_new()
{
    GtkWidget *but;
    struct stereo_button *stereo;

    but = gtk_check_button_new_with_label("stereo");
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(but), TRUE);
    gtk_widget_show(but);

    gtk_signal_connect(GTK_OBJECT(but), "toggled",
                (GtkSignalFunc) stereo_button_callback, NULL);

    stereo = malloc(sizeof(struct stereo_button));
    stereo->base = but;
    stereo->set_state = stereo_toggle_set_state;
    return stereo;
}
