/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "prefs.h"
#include "../callbacks.h"
#include "../hardware.h"
#include "popup_menu.h"
#include <gtk/gtk.h>
#include <stdio.h>
#include <malloc.h>
#include <time.h>
#ifdef USE_GNOME
#include <gnome.h>
#ifdef USE_PANEL
#include <dirent.h>
#include <sys/stat.h>
#include "applet.h"
#endif
#endif

/* preferences widgets and objects */
static int created = FALSE;
static GtkWidget *prefs_win, *prefs_notebook, *prefs_vbox;
static GtkWidget *prefs_bbox, *prefs_ok, *prefs_apply, *prefs_cancel;
static GtkWidget *prefs_gen_vbox, *prefs_gen_startup_frame, *prefs_gen_startup_table;
static GtkWidget *prefs_gen_alarm_startup, *prefs_gen_timer_startup;
static GtkWidget *prefs_gen_volume_startup, *prefs_gen_channel_startup;
static GtkWidget *prefs_gen_volume_val, *prefs_gen_channel_val;
static GtkWidget *prefs_gen_volume_box, *prefs_gen_channel_box;
static GtkWidget *prefs_gen_fft_val, *prefs_gen_fft_label, *prefs_gen_fft_box;
static GtkWidget *prefs_gen_plugins_startup;
static GtkWidget *prefs_gen_exit_frame, *prefs_gen_exit_vbox;
static GtkWidget *prefs_gen_exit_mute_hbox, *prefs_gen_exit_label;
static GtkWidget *prefs_gen_exit_mute_yes, *prefs_gen_exit_mute_no;
static GtkWidget *prefs_gen_exit_mute_ask;
static GtkWidget *prefs_gen_exit_save, *prefs_gen_start_hidden;
static GtkWidget *prefs_layout_frame, *prefs_layout_vbox;
static GtkWidget *prefs_layout_box1, *prefs_layout_label1, *prefs_layout_file;
static GtkWidget *prefs_layout_choose, *prefs_gen_verbose;
static GtkWidget *prefs_cron_vbox, *prefs_alarm_frame, *prefs_timer_frame;
static GtkWidget *prefs_timer_box, *prefs_timer_label, *prefs_timer_val;
static GtkWidget *prefs_layout_browse=0, *prefs_alarm_days_label;
static GtkWidget *prefs_alarm_vbox, *prefs_alarm_days, *prefs_alarm_days_menu;
static GtkWidget *prefs_alarm_days_box, *prefs_alarm_hour_l, *prefs_alarm_hour_v;
static GtkWidget *prefs_alarm_min_l, *prefs_alarm_min_v;
static GtkWidget *prefs_alarm_hour_b, *prefs_alarm_active;
static GtkWidget *prefs_alarm_same, *prefs_alarm_station_use;
static GtkWidget *prefs_alarm_station_box, *prefs_alarm_station_v;
static GtkWidget *prefs_stations_vbox, *prefs_stations_list, *prefs_stations_box;
static GtkWidget *prefs_stations_add, *prefs_stations_delete, *prefs_stations_chg;
static GtkWidget *prefs_stations_listen, *prefs_stations_curr;
static GtkWidget *prefs_stations_chan_edit, *prefs_stations_freq_edit;
static GtkWidget *prefs_stations_edit_box, *prefs_stations_scrolled;
static GtkWidget *prefs_cards_vbox, *prefs_cards_list, *prefs_cards_frame;
static GtkWidget *prefs_cards_hbox, *prefs_cards_configure, *prefs_cards_about;
static GtkWidget *prefs_cards_port_label, *prefs_cards_port_val;
static GtkWidget *prefs_cards_hbox2, *prefs_cards_menu;
static GtkWidget *prefs_plugins_vbox, *prefs_plugins_frame, *prefs_plugins_clist;
static GtkWidget *prefs_plugins_gen_vbox, *prefs_plugins_gen_scr;
static GtkWidget *prefs_plugins_gen_conf, *prefs_plugins_gen_about;
static GtkWidget *prefs_plugins_gen_hbox, *prefs_plugins_gen_enable;
static GtkWidget *prefs_applet_frame, *prefs_applet_vbox, *prefs_applet_style_hbox;
static GtkWidget *prefs_applet_style, *prefs_applet_style_off;
static GtkWidget *prefs_applet_style_none, *prefs_applet_style_text;
static GtkWidget *prefs_applet_style_skined, *prefs_applet_style_buts;;
static GtkWidget *prefs_applet_skined_frame, *prefs_applet_skined_label;
static GtkWidget *prefs_applet_skined_dir, *prefs_applet_skined_list;
static GtkWidget *prefs_applet_skined_vbox, *prefs_applet_skined_hbox;
static GtkWidget *prefs_applet_skined_scr;

static char *stations_title[2] = { "Station", "Frequency (Mhz)" };
static char *plugins_title[1] = { "Available General Plugins" };
static char *applet_skin_title[1] = { "Applet Skins" };
extern struct radio_config *config;
static struct alarm Alarm;
static int last_day;
static CardPlugin *new_card = 0;
static gboolean updating_plugin_list = 0;
static gchar *prefs_applet_skindir = 0;
static int current_applet_style;

/* preferences gui construction */

static void prefs_apply_changes();

static
gint prefs_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
    gtk_widget_hide(prefs_win);
    return(TRUE);
}

static
void prefs_layout_browse_ok(GtkWidget *w,gpointer data)
{
    gtk_entry_set_text(GTK_ENTRY(prefs_layout_file),
		gtk_file_selection_get_filename(GTK_FILE_SELECTION
		(prefs_layout_browse)));
    gtk_widget_destroy(prefs_layout_browse);
}

static
void prefs_layout_browse_cb(GtkWidget *w,gpointer data)
{
    if (!prefs_layout_browse)
    {
	prefs_layout_browse = gtk_file_selection_new ("Layout selection");
	gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(
		prefs_layout_browse)->cancel_button),"clicked",
		GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(
		prefs_layout_browse));
	gtk_signal_connect(GTK_OBJECT(prefs_layout_browse),"destroy",
		GTK_SIGNAL_FUNC(gtk_widget_destroyed),&prefs_layout_browse);
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(prefs_layout_browse)
		->ok_button),"clicked",GTK_SIGNAL_FUNC(prefs_layout_browse_ok)
		,NULL);
	gtk_widget_show(prefs_layout_browse);
    }
}

static
void prefs_ok_cb(GtkWidget *w,gpointer data)
{
    prefs_apply_changes();
    gtk_widget_hide(prefs_win);
}

static
void prefs_apply_cb(GtkWidget *w,gpointer data)
{
    prefs_apply_changes();
}

static
void prefs_cancel_cb(GtkWidget *w,gpointer data)
{
    gtk_widget_hide(prefs_win);
}

static
void prefs_stations_clicked(GtkWidget *w,gpointer data)
{
    int row;    
    gchar *text;        

    if(GTK_CLIST(prefs_stations_list)->selection)
    {
	gtk_widget_set_sensitive(prefs_stations_delete,1);
	gtk_widget_set_sensitive(prefs_stations_chg,1);
	gtk_widget_set_sensitive(prefs_stations_listen,1);

	row = (gint)GTK_CLIST(prefs_stations_list)->selection->data;
	gtk_clist_get_text(GTK_CLIST(prefs_stations_list), row, 0, &text);
	gtk_entry_set_text (GTK_ENTRY(prefs_stations_chan_edit), text);
	gtk_clist_get_text(GTK_CLIST(prefs_stations_list), row, 1, &text);
	gtk_entry_set_text (GTK_ENTRY(prefs_stations_freq_edit), text);
    }
    else
    {
	gtk_widget_set_sensitive(prefs_stations_delete,0);
	gtk_widget_set_sensitive(prefs_stations_chg,0);
	gtk_widget_set_sensitive(prefs_stations_listen,0);
	gtk_entry_set_text (GTK_ENTRY(prefs_stations_chan_edit), "");
	gtk_entry_set_text (GTK_ENTRY(prefs_stations_freq_edit), "");
    }
}

static
void prefs_clicked_listen(GtkWidget *w,gpointer data)
{
    int row;
    gchar *text;
    double f;

    row = (gint)GTK_CLIST(prefs_stations_list)->selection->data;
    gtk_clist_get_text(GTK_CLIST(prefs_stations_list), row, 1, &text);

    if (sscanf(text, "%lf", &f) == 1)
	callback_set_freq(NULL, f);
    else
	printf("gtuner: invalid frequency in row %i\n", row);
}

static
void prefs_clicked_delete(GtkWidget *w,gpointer data)
{
    int row;
    row = (gint)GTK_CLIST(prefs_stations_list)->selection->data;
    gtk_clist_remove(GTK_CLIST(prefs_stations_list), row);
}

static
void prefs_clicked_chg(GtkWidget *w,gpointer data)
{
    int row;
    gchar *text;
    double f;
    row = (gint)GTK_CLIST(prefs_stations_list)->selection->data;

    text = gtk_entry_get_text (GTK_ENTRY(prefs_stations_freq_edit));
    if (sscanf(text, "%lf", &f) != 1)
    {
	printf("gtuner: entry in the frequency box is not a valid number\n");
	return;
    }
    if ((f < card_get_min_frequency ()) || (f > card_get_max_frequency ()))
    {
	printf("gtuner: frequency out of range\n");
	return;
    }

    gtk_clist_set_text(GTK_CLIST(prefs_stations_list), row, 0,
			gtk_entry_get_text (GTK_ENTRY(prefs_stations_chan_edit)));
    gtk_clist_set_text(GTK_CLIST(prefs_stations_list), row, 1,
			gtk_entry_get_text (GTK_ENTRY(prefs_stations_freq_edit)));
}

static
void prefs_changed_add(GtkWidget *w,gpointer data)
{
    if (strcmp(gtk_entry_get_text
		(GTK_ENTRY(prefs_stations_chan_edit)),"")!=0)
    {
	gtk_widget_set_sensitive(prefs_stations_curr,1);
	if (strcmp(gtk_entry_get_text
		(GTK_ENTRY(prefs_stations_freq_edit)),"")!=0)
	{
	    gtk_widget_set_sensitive(prefs_stations_add,1);
	    return;
	}
	gtk_widget_set_sensitive(prefs_stations_add,0);
	return;
    }
    gtk_widget_set_sensitive(prefs_stations_add,0);
    gtk_widget_set_sensitive(prefs_stations_curr,0);
}

static
void prefs_clicked_add(GtkWidget *w,gpointer data)
{
    char *text[2], *test;
    double f;

    test = gtk_entry_get_text (GTK_ENTRY(prefs_stations_freq_edit));
    if (sscanf(test, "%lf", &f) != 1)
    {
        printf("gtuner: entry in the frequency box is not a valid number\n");
        return;
    }
    if ((f < card_get_min_frequency ()) || (f > card_get_max_frequency ()))
    {
        printf("gtuner: frequency out of range\n");
        return;
    }

    text[0] = gtk_entry_get_text (GTK_ENTRY(prefs_stations_chan_edit));
    text[1] = gtk_entry_get_text (GTK_ENTRY(prefs_stations_freq_edit));
    gtk_clist_append(GTK_CLIST(prefs_stations_list), text);
}

static
void prefs_clicked_curr(GtkWidget *w,gpointer data)
{
    char text[9];

    snprintf(text, 8, "%3.2f", card_get_frequency ());
    gtk_entry_set_text (GTK_ENTRY(prefs_stations_freq_edit), text);
}

static
void prefs_alarm_callback(GtkWidget *w,gpointer data)
{
    int day = (int)data;
    int today, temp;
    char val[5];
    char *v;

    v = gtk_entry_get_text (GTK_ENTRY(prefs_alarm_hour_v));
    if (sscanf(v, "%i", &temp) == 1)
	Alarm.hour[last_day] = temp;
    v = gtk_entry_get_text (GTK_ENTRY(prefs_alarm_min_v));
    if (sscanf(v, "%i", &temp) == 1)
	Alarm.minute[last_day] = temp;
    if (GTK_TOGGLE_BUTTON (prefs_alarm_station_use)->active)
    {
	v = gtk_entry_get_text (GTK_ENTRY(prefs_alarm_station_v));
	if (sscanf(v, "%i", &temp) == 1)
	    Alarm.station[last_day] = temp;
	else
	    Alarm.station[last_day] = -1;
    }
    else
	Alarm.station[last_day] = -1;

    if (GTK_TOGGLE_BUTTON (prefs_alarm_active)->active)
	Alarm.day_bitmask |= (1 << last_day);
    else
	Alarm.day_bitmask &= WEEK - (1 << last_day);

    switch(day)
    {
	case SUN: today = 0; break;
	case MON: today = 1; break;
	case TUE: today = 2; break;
	case WED: today = 3; break;
	case THR: today = 4; break;
	case FRI: today = 5; break;
	case SAT: today = 6; break;
	default:
		printf("gtuner: invalid day %i\n", day);
		today = 0;
		break;
    }
    last_day = today;

        gtk_option_menu_set_history (GTK_OPTION_MENU(prefs_alarm_days),today);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (prefs_alarm_active),
				Alarm.day_bitmask & (1 << today));
	snprintf(val, 4, "%i", Alarm.hour[today]);
	gtk_entry_set_text (GTK_ENTRY(prefs_alarm_hour_v), val);
	snprintf(val, 4, "%i", Alarm.minute[today]);
	gtk_entry_set_text (GTK_ENTRY(prefs_alarm_min_v), val);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prefs_alarm_station_use),
					Alarm.station[today] != -1);
	if (Alarm.station[today] != -1)
	{
	    snprintf(val, 4, "%i", Alarm.station[today]);
	    gtk_entry_set_text (GTK_ENTRY(prefs_alarm_station_v), val);
	}
	else
	    gtk_entry_set_text (GTK_ENTRY(prefs_alarm_station_v), "");

}

static
void prefs_alarm_same_clicked(GtkWidget *w,gpointer data)
{
    int i;

    prefs_alarm_callback(w,(char*)(1 << last_day));
    for (i=0; i<7; i++)
    {
	Alarm.hour[i] = Alarm.hour[last_day];
	Alarm.minute[i] = Alarm.minute[last_day];
	Alarm.station[i] = Alarm.station[last_day];
    }
    Alarm.day_bitmask = (WEEK) * (1 && (Alarm.day_bitmask & (1 << last_day)));
}

static
void prefs_cards_callback(GtkWidget *w,gpointer data)
{
    int row = (int)data;
    GList *list;

    CardPlugin *cp;

    list = get_card_list();
    cp = (CardPlugin*)g_list_nth(list, row)->data;

    if (cp)
    {
	gtk_widget_set_sensitive(prefs_cards_about, cp->about!=NULL);
	gtk_widget_set_sensitive(prefs_cards_configure,cp->configure!=NULL);
	new_card = cp;
    }
    else
    {
	gtk_widget_set_sensitive(prefs_cards_about, 0);
	gtk_widget_set_sensitive(prefs_cards_configure, 0);
    }
}

static
void prefs_cards_conf_clicked(GtkWidget *w,gpointer data)
{
    if (new_card)
	if (new_card->configure)
	    new_card->configure();
}

static
void prefs_cards_about_clicked(GtkWidget *w,gpointer data)
{
    if (new_card)
	if (new_card->about)
	    new_card->about();
}

static void plugins_list_refresh()
{
    int i;
    char *row[1];
    gtk_clist_clear (GTK_CLIST(prefs_plugins_clist));

    for (i=0; i<g_list_length(plugin_list); i++)
    {
	GenericPlugin *p = (GenericPlugin*)g_list_nth(plugin_list, i)->data;
	char *s;
	if (plugin_enabled(p)) s = g_strdup(" (enabled)");
	else s = g_strdup("");
	row[0] = g_strconcat(p->description, "[", g_basename(p->filename),
			"]", s, NULL);
	g_free(s);
	gtk_clist_append(GTK_CLIST(prefs_plugins_clist), row);
	g_free(row[0]);
    }
    gtk_widget_set_sensitive(prefs_plugins_gen_about, FALSE);
    gtk_widget_set_sensitive(prefs_plugins_gen_conf, FALSE);
    gtk_widget_set_sensitive(prefs_plugins_gen_enable, FALSE);
}

static void prefs_plugins_about_clicked(GtkWidget *w,gpointer data)
{
    int row;
    GenericPlugin *p;

    if(GTK_CLIST(prefs_plugins_clist)->selection)
    {
	row = (gint)GTK_CLIST(prefs_plugins_clist)->selection->data;
	p = (GenericPlugin*)g_list_nth(plugin_list, row)->data;
	if (p->about) p->about();
    }
}

static void prefs_plugins_enable_clicked(GtkWidget *w,gpointer data)
{
    int row;

    if (updating_plugin_list) return;
    if(GTK_CLIST(prefs_plugins_clist)->selection)
    {
	row = (gint)GTK_CLIST(prefs_plugins_clist)->selection->data;
	enable_plugin(row, GTK_TOGGLE_BUTTON(w)->active);
	plugins_list_refresh();
    }
}

static void prefs_plugins_configure_clicked(GtkWidget *w,gpointer data)
{
    int row;
    GenericPlugin *p;

    if(GTK_CLIST(prefs_plugins_clist)->selection)
    {
	row = (gint)GTK_CLIST(prefs_plugins_clist)->selection->data;
	p = (GenericPlugin*)g_list_nth(plugin_list, row)->data;
	if (p->configure) p->configure();
    }
}

static void prefs_plugins_list_clicked(GtkWidget *w,gpointer data)
{
    int row;
    GenericPlugin *p;
    if(GTK_CLIST(prefs_plugins_clist)->selection)
    {
	row = (gint)GTK_CLIST(prefs_plugins_clist)->selection->data;
	p = (GenericPlugin*)g_list_nth(plugin_list, row)->data;
	gtk_widget_set_sensitive(prefs_plugins_gen_conf, (p->configure)!=0);
	gtk_widget_set_sensitive(prefs_plugins_gen_about, (p->about)!=0);
	gtk_widget_set_sensitive(prefs_plugins_gen_enable, TRUE);
	updating_plugin_list = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(
				prefs_plugins_gen_enable), plugin_enabled(p));
	updating_plugin_list = 0;
    } else
    {
	gtk_widget_set_sensitive(prefs_plugins_gen_about, FALSE);
	gtk_widget_set_sensitive(prefs_plugins_gen_conf, FALSE);
	gtk_widget_set_sensitive(prefs_plugins_gen_enable, FALSE);
    }
}

static void prefs_applet_list_clicked(GtkWidget *clist, gint row, gint column,
				GdkEventButton *bevent, gpointer data)
{
    char *text = gtk_clist_get_row_data(GTK_CLIST(clist), row);
    if (text) gtk_entry_set_text(GTK_ENTRY(prefs_applet_skined_dir),text);
}

void create_preferences ()
{
    GtkWidget *item;
    GList *node;
    gchar *text;
    int i,j;

    if (created) return;
    created = TRUE;

    prefs_win = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_set_title(GTK_WINDOW(prefs_win),"gtuner: Preferences");
    gtk_window_set_position(GTK_WINDOW(prefs_win),GTK_WIN_POS_CENTER);
    gtk_window_set_policy (GTK_WINDOW(prefs_win), FALSE,FALSE,FALSE);
    gtk_signal_connect(GTK_OBJECT(prefs_win),"delete_event",
			GTK_SIGNAL_FUNC(prefs_delete_event), NULL);
    gtk_container_border_width(GTK_CONTAINER(prefs_win),5);

    prefs_vbox = gtk_vbox_new(FALSE, 5);
    prefs_notebook = gtk_notebook_new();
    gtk_notebook_set_scrollable (GTK_NOTEBOOK(prefs_notebook), TRUE);
    gtk_container_add (GTK_CONTAINER(prefs_win), prefs_vbox);
    gtk_box_pack_start(GTK_BOX(prefs_vbox),prefs_notebook,TRUE,TRUE,0);

    /* General Tag */

    prefs_gen_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_gen_vbox),5);

    prefs_gen_startup_frame = gtk_frame_new("Startup Options");
    gtk_box_pack_start(GTK_BOX(prefs_gen_vbox),
				prefs_gen_startup_frame,FALSE,TRUE,0);
    prefs_gen_startup_table = gtk_table_new(2,4, FALSE);
    gtk_container_add (GTK_CONTAINER(prefs_gen_startup_frame),
						prefs_gen_startup_table);
    gtk_container_border_width(GTK_CONTAINER(prefs_gen_startup_table), 5);

    prefs_gen_alarm_startup = gtk_check_button_new_with_label("Alarm On");
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_alarm_startup,0,1,0,1);
    prefs_gen_timer_startup = gtk_check_button_new_with_label("Sleep Timer On");
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_timer_startup,1,2,0,1);

    prefs_gen_volume_box = gtk_hbox_new(FALSE, 5);
    prefs_gen_volume_startup = gtk_check_button_new_with_label("Set Volume");
    gtk_box_pack_start(GTK_BOX(prefs_gen_volume_box),
				prefs_gen_volume_startup, TRUE, TRUE, 0);
    prefs_gen_volume_val = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(prefs_gen_volume_val,30,-1);
    gtk_box_pack_start(GTK_BOX(prefs_gen_volume_box),
				prefs_gen_volume_val, TRUE, TRUE, 0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_volume_box,0,1,1,2);
    prefs_gen_channel_box = gtk_hbox_new(FALSE, 5);
    prefs_gen_channel_startup = gtk_check_button_new_with_label("Set Channel");
    gtk_box_pack_start(GTK_BOX(prefs_gen_channel_box),
				prefs_gen_channel_startup, TRUE, TRUE, 0);
    prefs_gen_channel_val = gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_gen_channel_val,30,-1);
    gtk_box_pack_start(GTK_BOX(prefs_gen_channel_box),    
				prefs_gen_channel_val, TRUE, TRUE, 0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_channel_box,1,2,1,2);

    prefs_gen_fft_box = gtk_hbox_new(FALSE, 5);
    prefs_gen_fft_label = gtk_label_new("LCD FFT Style");
    gtk_box_pack_start(GTK_BOX(prefs_gen_fft_box),
				prefs_gen_fft_label, TRUE, TRUE, 0);
    prefs_gen_fft_val = gtk_entry_new_with_max_length(1);
    gtk_widget_set_usize(prefs_gen_fft_val,20,-1);
    gtk_box_pack_start(GTK_BOX(prefs_gen_fft_box),
				prefs_gen_fft_val, TRUE, TRUE, 0);
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_fft_box,0,1,2,3);
    prefs_gen_plugins_startup = gtk_check_button_new_with_label
	    					("Load Generic_Plugins");
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_plugins_startup,1,2,2,3);
    prefs_gen_verbose = gtk_check_button_new_with_label("Verbose Messages");
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_verbose,0,1,3,4);
    prefs_gen_start_hidden = gtk_check_button_new_with_label("Start Hidden");
    gtk_table_attach_defaults(GTK_TABLE(prefs_gen_startup_table),
				prefs_gen_start_hidden,1,2,3,4);
#ifndef USE_PANEL
    gtk_widget_set_sensitive(prefs_gen_start_hidden, FALSE);
#endif

    prefs_layout_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_layout_vbox),5);

    prefs_layout_frame = gtk_frame_new("Layout Options");
    gtk_container_add(GTK_CONTAINER(prefs_layout_frame), prefs_layout_vbox);
    gtk_box_pack_start(GTK_BOX(prefs_gen_vbox),
                                prefs_layout_frame, FALSE, TRUE, 0);

    prefs_layout_box1 = gtk_hbox_new(FALSE, 5);
    prefs_layout_label1 = gtk_label_new("Layout File");
    prefs_layout_file = gtk_entry_new();
    prefs_layout_choose = gtk_button_new_with_label("Choose");
    gtk_signal_connect(GTK_OBJECT(prefs_layout_choose),"clicked",
			GTK_SIGNAL_FUNC(prefs_layout_browse_cb),NULL);

    gtk_box_pack_start(GTK_BOX(prefs_layout_box1),
				prefs_layout_label1,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_layout_box1),
				prefs_layout_file,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_layout_box1),
				prefs_layout_choose,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_layout_vbox),
				prefs_layout_box1,TRUE,TRUE,0);

    prefs_gen_exit_frame = gtk_frame_new("Exit Options");
    gtk_box_pack_start(GTK_BOX(prefs_gen_vbox),
				prefs_gen_exit_frame, FALSE, TRUE, 0);

    prefs_gen_exit_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_gen_exit_vbox),5);
    gtk_container_add(GTK_CONTAINER(prefs_gen_exit_frame), prefs_gen_exit_vbox);
    prefs_gen_exit_mute_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_vbox),
				prefs_gen_exit_mute_hbox, FALSE, TRUE, 0);
    prefs_gen_exit_label = gtk_label_new("Mute on exit");
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_mute_hbox), prefs_gen_exit_label,
				FALSE, TRUE, 0);
    prefs_gen_exit_mute_yes = gtk_radio_button_new_with_label (NULL, "Yes");
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_mute_hbox),
		    prefs_gen_exit_mute_yes, FALSE, TRUE, 0);
    prefs_gen_exit_mute_no = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_gen_exit_mute_yes)), "No");
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_mute_hbox),
		    prefs_gen_exit_mute_no, FALSE, TRUE, 0);
    prefs_gen_exit_mute_ask = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_gen_exit_mute_yes)), "Ask");
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_mute_hbox),
		    prefs_gen_exit_mute_ask, FALSE, TRUE, 0);
    prefs_gen_exit_save = gtk_check_button_new_with_label(
		    "Save settings on exit");
    gtk_box_pack_start(GTK_BOX(prefs_gen_exit_vbox),
		    prefs_gen_exit_save, FALSE, TRUE, 0);

    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_gen_vbox, gtk_label_new("General"));

    /* Cron */

    prefs_cron_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_cron_vbox),5);

    prefs_alarm_frame = gtk_frame_new("Alarm Options");
    gtk_box_pack_start(GTK_BOX(prefs_cron_vbox), prefs_alarm_frame,FALSE,TRUE,0);
    prefs_alarm_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_alarm_vbox),5);
    gtk_container_add(GTK_CONTAINER(prefs_alarm_frame), prefs_alarm_vbox);

    prefs_alarm_same = gtk_button_new_with_label
			("Change all days to be the same as this");
    gtk_signal_connect(GTK_OBJECT(prefs_alarm_same),"clicked",
			GTK_SIGNAL_FUNC(prefs_alarm_same_clicked),NULL);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_vbox),
			prefs_alarm_same,TRUE,TRUE,0);

    prefs_alarm_days_box = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_vbox),
			prefs_alarm_days_box,TRUE,TRUE,0);
    prefs_alarm_days_label = gtk_label_new("Select a day:");
    gtk_box_pack_start(GTK_BOX(prefs_alarm_days_box),
                        prefs_alarm_days_label,FALSE,TRUE,0);
    prefs_alarm_days = gtk_option_menu_new();
    gtk_box_pack_start(GTK_BOX(prefs_alarm_days_box),
                        prefs_alarm_days,TRUE,TRUE,0);
    prefs_alarm_days_menu = gtk_menu_new();

    item=gtk_menu_item_new_with_label("Sunday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)SUN);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Monday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)MON);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Tuesday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)TUE);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Wednesday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)WED);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Thursday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)THR);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Friday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)FRI);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);
    item=gtk_menu_item_new_with_label("Saturday"); gtk_widget_show(item);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_alarm_callback),(char*)SAT);
    gtk_menu_append(GTK_MENU(prefs_alarm_days_menu),item);

    gtk_option_menu_remove_menu(GTK_OPTION_MENU(prefs_alarm_days));
    gtk_option_menu_set_menu(GTK_OPTION_MENU(prefs_alarm_days),
				prefs_alarm_days_menu);

    prefs_alarm_hour_l = gtk_label_new("Hour:");
    prefs_alarm_hour_v = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(prefs_alarm_hour_v,30,-1);
    prefs_alarm_min_l = gtk_label_new("Minute:");
    prefs_alarm_min_v = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(prefs_alarm_min_v,30,-1);

    prefs_alarm_active = gtk_check_button_new_with_label("Alarm active");
    gtk_box_pack_start(GTK_BOX(prefs_alarm_vbox),
                        prefs_alarm_active,TRUE,TRUE,0);

    prefs_alarm_hour_b = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_hour_b),
				prefs_alarm_hour_l,FALSE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_hour_b),
				prefs_alarm_hour_v,FALSE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_hour_b),
				prefs_alarm_min_l,FALSE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_hour_b),
				prefs_alarm_min_v,FALSE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_vbox),
			prefs_alarm_hour_b,TRUE,TRUE,0);

    prefs_alarm_station_box = gtk_hbox_new(FALSE, 5);
    prefs_alarm_station_use = gtk_check_button_new_with_label("Change Station to:");
    prefs_alarm_station_v = gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_alarm_station_v,30,-1);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_station_box), prefs_alarm_station_use,
				FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_station_box), prefs_alarm_station_v,
				FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_alarm_vbox), prefs_alarm_station_box,
                                FALSE, TRUE, 0);

    prefs_timer_frame = gtk_frame_new("Sleep Timer Options");
    gtk_box_pack_start(GTK_BOX(prefs_cron_vbox), prefs_timer_frame,TRUE,TRUE,0);

    prefs_timer_box = gtk_hbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_timer_box),5);
    prefs_timer_label = gtk_label_new("Sleep time (min)");
    gtk_box_pack_start(GTK_BOX(prefs_timer_box),
                                prefs_timer_label, FALSE, TRUE, 0);
    prefs_timer_val = gtk_entry_new_with_max_length(3);
    gtk_widget_set_usize(prefs_timer_val,30,-1);
    gtk_box_pack_start(GTK_BOX(prefs_timer_box),
				prefs_timer_val, FALSE, TRUE, 0);

    gtk_container_add(GTK_CONTAINER(prefs_timer_frame), prefs_timer_box);

    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_cron_vbox, gtk_label_new("Cronological"));

    /* Stations */

    prefs_stations_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_stations_vbox),5);

    prefs_stations_scrolled = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_set_usize(prefs_stations_scrolled, -1, 200);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW
		(prefs_stations_scrolled), GTK_POLICY_AUTOMATIC,
		GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX(prefs_stations_vbox), prefs_stations_scrolled,
			TRUE, TRUE, 0);
    prefs_stations_list = gtk_clist_new_with_titles (2, stations_title);
    gtk_container_add(GTK_CONTAINER(prefs_stations_scrolled),
			prefs_stations_list);
    gtk_clist_set_column_justification(GTK_CLIST(prefs_stations_list), 1,
                                             GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_width(GTK_CLIST(prefs_stations_list), 0, 150);
    gtk_clist_set_column_width(GTK_CLIST(prefs_stations_list), 1, 80);
    gtk_clist_column_titles_passive (GTK_CLIST(prefs_stations_list));
    gtk_clist_set_reorderable (GTK_CLIST(prefs_stations_list), TRUE);
    gtk_clist_set_use_drag_icons (GTK_CLIST(prefs_stations_list), TRUE);
    gtk_clist_set_selection_mode(GTK_CLIST(prefs_stations_list),
		    GTK_SELECTION_SINGLE);

    gtk_signal_connect(GTK_OBJECT(prefs_stations_list),"select_row",
			GTK_SIGNAL_FUNC(prefs_stations_clicked),NULL);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_list),"unselect_row",
			GTK_SIGNAL_FUNC(prefs_stations_clicked),NULL);

    prefs_stations_edit_box = gtk_hbox_new(FALSE, 5);
    prefs_stations_chan_edit = gtk_entry_new();
    prefs_stations_freq_edit = gtk_entry_new_with_max_length(6);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_chan_edit),"changed",
			GTK_SIGNAL_FUNC(prefs_changed_add),NULL);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_freq_edit),"changed",
			GTK_SIGNAL_FUNC(prefs_changed_add),NULL);
    gtk_widget_set_usize(prefs_stations_freq_edit,50,-1);
    gtk_box_pack_start(GTK_BOX(prefs_stations_edit_box),
			prefs_stations_chan_edit, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_stations_edit_box),
			prefs_stations_freq_edit, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_stations_vbox),
			prefs_stations_edit_box, FALSE, TRUE, 0);

    prefs_stations_box = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_stations_vbox), prefs_stations_box,
			FALSE, TRUE, 0);
    prefs_stations_add = gtk_button_new_with_label("Add");
    gtk_box_pack_start(GTK_BOX(prefs_stations_box), prefs_stations_add,
			TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_add),"clicked",
			GTK_SIGNAL_FUNC(prefs_clicked_add),NULL);
    prefs_stations_delete = gtk_button_new_with_label("Delete");
    gtk_box_pack_start(GTK_BOX(prefs_stations_box), prefs_stations_delete,
			TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_delete),"clicked",
			GTK_SIGNAL_FUNC(prefs_clicked_delete),NULL);
    prefs_stations_chg = gtk_button_new_with_label("Change");
    gtk_box_pack_start(GTK_BOX(prefs_stations_box), prefs_stations_chg,
			TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_chg),"clicked",
			GTK_SIGNAL_FUNC(prefs_clicked_chg),NULL);
    prefs_stations_listen = gtk_button_new_with_label("Listen");
    gtk_box_pack_start(GTK_BOX(prefs_stations_box), prefs_stations_listen,
			TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_listen),"clicked",
			GTK_SIGNAL_FUNC(prefs_clicked_listen),NULL);
    prefs_stations_curr = gtk_button_new_with_label("Current Freq");
    gtk_box_pack_start(GTK_BOX(prefs_stations_box), prefs_stations_curr,
			TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(prefs_stations_curr),"clicked",
			GTK_SIGNAL_FUNC(prefs_clicked_curr),NULL);

    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_stations_vbox, gtk_label_new("Stations"));

    /* Radio Card Page */
    
    prefs_cards_frame = gtk_frame_new("Radio Card Plugins");
    gtk_container_border_width(GTK_CONTAINER(prefs_cards_frame),5);
   
    prefs_cards_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_cards_vbox),5);
    gtk_container_add(GTK_CONTAINER(prefs_cards_frame), prefs_cards_vbox);
   
    prefs_cards_list = gtk_option_menu_new();
    gtk_box_pack_start(GTK_BOX(prefs_cards_vbox), prefs_cards_list,
			    FALSE, FALSE, 0);
    gtk_option_menu_remove_menu(GTK_OPTION_MENU(prefs_cards_list));
    prefs_cards_menu = gtk_menu_new();

    node = get_card_list();
    i = 0;
    j = -1;
    if (config->card_name)
    while (node)
    {
	text = g_strdup(((CardPlugin*)node->data)->description);

	if (strcmp(((CardPlugin*)node->data)->filename, config->card_name)==0)
	{
	    j = i;
	    new_card = (CardPlugin*)node->data;
	}
	
	item=gtk_menu_item_new_with_label(text); gtk_widget_show(item);
	gtk_signal_connect(GTK_OBJECT(item),"activate",
			GTK_SIGNAL_FUNC(prefs_cards_callback), (char*)i);
	gtk_menu_append(GTK_MENU(prefs_cards_menu),item);

	node = node->next;
	free(text);
	i++;
    }
    gtk_option_menu_set_menu(GTK_OPTION_MENU(prefs_cards_list),
				prefs_cards_menu);

    prefs_cards_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_cards_vbox),
				prefs_cards_hbox, FALSE, FALSE, 0);
    prefs_cards_configure = gtk_button_new_with_label("Configure");
    gtk_signal_connect(GTK_OBJECT(prefs_cards_configure),"clicked",
			GTK_SIGNAL_FUNC(prefs_cards_conf_clicked),NULL);
    prefs_cards_about = gtk_button_new_with_label("About");
    gtk_signal_connect(GTK_OBJECT(prefs_cards_about),"clicked",
			GTK_SIGNAL_FUNC(prefs_cards_about_clicked),NULL);
    gtk_box_pack_start(GTK_BOX(prefs_cards_hbox), prefs_cards_configure,
				    TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_cards_hbox), prefs_cards_about,
				    TRUE, TRUE, 0);

    if (j != -1)
    {
	gtk_widget_set_sensitive(prefs_cards_about, new_card->about!=NULL);
	gtk_widget_set_sensitive(prefs_cards_configure, new_card->configure!=NULL);
	gtk_option_menu_set_history (GTK_OPTION_MENU(prefs_cards_list), j);
    } else
    {
	gtk_widget_set_sensitive(prefs_cards_about, 0);
	gtk_widget_set_sensitive(prefs_cards_configure, 0);
    }

    prefs_cards_hbox2 = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_cards_vbox),
				prefs_cards_hbox2, FALSE, FALSE, 0);
    
    prefs_cards_port_label = gtk_label_new("Card Port");
    prefs_cards_port_val = gtk_entry_new_with_max_length(6);
    gtk_widget_set_usize(prefs_cards_port_val,50,-1);
    gtk_box_pack_start(GTK_BOX(prefs_cards_hbox2), prefs_cards_port_label,
				    FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_cards_hbox2), prefs_cards_port_val,
				    FALSE, FALSE, 0);

    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_cards_frame, gtk_label_new("Radio Cards"));
    
    /* Plugins */

    prefs_plugins_vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_border_width(GTK_CONTAINER(prefs_plugins_vbox), 5);
    prefs_plugins_frame = gtk_frame_new("General Plugins");
    gtk_box_pack_start(GTK_BOX(prefs_plugins_vbox), prefs_plugins_frame,
		    FALSE, FALSE, 0);
    prefs_plugins_gen_scr = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_set_usize(prefs_plugins_gen_scr, -1, 100);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW
		(prefs_plugins_gen_scr), GTK_POLICY_AUTOMATIC,
		GTK_POLICY_AUTOMATIC);
    prefs_plugins_clist = gtk_clist_new_with_titles(1, plugins_title);
    gtk_clist_column_titles_passive (GTK_CLIST(prefs_plugins_clist));
    gtk_signal_connect(GTK_OBJECT(prefs_plugins_clist),"select_row",
		    GTK_SIGNAL_FUNC(prefs_plugins_list_clicked),NULL);
    gtk_signal_connect(GTK_OBJECT(prefs_plugins_clist),"unselect_row",
		    GTK_SIGNAL_FUNC(prefs_plugins_list_clicked),NULL);
    prefs_plugins_gen_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_plugins_gen_vbox), 5);
    gtk_container_add(GTK_CONTAINER(prefs_plugins_frame),
		    prefs_plugins_gen_vbox);
    gtk_container_add(GTK_CONTAINER(prefs_plugins_gen_scr),
			prefs_plugins_clist);
    gtk_box_pack_start(GTK_BOX(prefs_plugins_gen_vbox), prefs_plugins_gen_scr,
		    FALSE, FALSE, 0);
    prefs_plugins_gen_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_plugins_gen_vbox), prefs_plugins_gen_hbox,
		    FALSE, FALSE, 0);
    prefs_plugins_gen_conf = gtk_button_new_with_label("Configure");
    gtk_signal_connect(GTK_OBJECT(prefs_plugins_gen_conf ),"clicked",
			GTK_SIGNAL_FUNC(prefs_plugins_configure_clicked),NULL);
    prefs_plugins_gen_about = gtk_button_new_with_label("About");
    gtk_signal_connect(GTK_OBJECT(prefs_plugins_gen_about ),"clicked",
			GTK_SIGNAL_FUNC(prefs_plugins_about_clicked),NULL);
    gtk_box_pack_start(GTK_BOX(prefs_plugins_gen_hbox), prefs_plugins_gen_conf,
		    TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_plugins_gen_hbox), prefs_plugins_gen_about,
		    TRUE, TRUE, 0);
    prefs_plugins_gen_enable = gtk_check_button_new_with_label("Enable");
    gtk_signal_connect(GTK_OBJECT(prefs_plugins_gen_enable),"toggled",
		    GTK_SIGNAL_FUNC(prefs_plugins_enable_clicked),NULL);
    gtk_box_pack_start(GTK_BOX(prefs_plugins_gen_hbox), prefs_plugins_gen_enable,
		    TRUE, TRUE, 0);
    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_plugins_vbox, gtk_label_new("Plugins"));

    /* Panel Applet Config */

    prefs_applet_frame = gtk_frame_new("Gnome Panel Applet");
    gtk_container_border_width(GTK_CONTAINER(prefs_applet_frame), 5);
    prefs_applet_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_applet_vbox), 5);
    gtk_container_add(GTK_CONTAINER(prefs_applet_frame), prefs_applet_vbox);
   
    prefs_applet_style_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_applet_vbox),  prefs_applet_style_hbox,
		    FALSE, FALSE, 0);
    prefs_applet_style = gtk_label_new("Style:");
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),  prefs_applet_style,
		    FALSE, FALSE, 0);
    prefs_applet_style_off = gtk_radio_button_new_with_label(NULL, "Hide");
    prefs_applet_style_none = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_applet_style_off)), "None");
    prefs_applet_style_text = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_applet_style_off)), "Text");
    prefs_applet_style_buts = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_applet_style_off)), "Buttons");
    prefs_applet_style_skined = gtk_radio_button_new_with_label(
		    gtk_radio_button_group (GTK_RADIO_BUTTON
			    (prefs_applet_style_off)), "Skined");
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),
		    prefs_applet_style_off, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),
		    prefs_applet_style_none, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),
		    prefs_applet_style_text, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),
		    prefs_applet_style_buts, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(prefs_applet_style_hbox),
		    prefs_applet_style_skined, FALSE, FALSE, 0);


    prefs_applet_skined_frame = gtk_frame_new("Available Skins");
    prefs_applet_skined_vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_border_width(GTK_CONTAINER(prefs_applet_skined_vbox), 5);
    gtk_box_pack_start(GTK_BOX(prefs_applet_vbox),
		    prefs_applet_skined_frame, FALSE, FALSE, 0);
    gtk_container_add(GTK_CONTAINER(prefs_applet_skined_frame),
		    prefs_applet_skined_vbox);
    prefs_applet_skined_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(prefs_applet_skined_vbox),
		    prefs_applet_skined_hbox, FALSE, FALSE, 0);
    
    prefs_applet_skined_label = gtk_label_new("Skin Directory:");
    gtk_box_pack_start(GTK_BOX(prefs_applet_skined_hbox),
		    prefs_applet_skined_label, FALSE, FALSE, 0);
    prefs_applet_skined_dir = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(prefs_applet_skined_hbox),
		    prefs_applet_skined_dir, TRUE, TRUE, 0);
    prefs_applet_skined_scr = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_set_usize(prefs_applet_skined_scr, -1, 150);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW
		(prefs_applet_skined_scr), GTK_POLICY_AUTOMATIC,
		GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX(prefs_applet_skined_vbox),
		    prefs_applet_skined_scr, FALSE, FALSE, 0);
    prefs_applet_skined_list = gtk_clist_new_with_titles(
		    1,applet_skin_title);
    gtk_clist_column_titles_passive (
		    GTK_CLIST(prefs_applet_skined_list));
    gtk_signal_connect(GTK_OBJECT(prefs_applet_skined_list),"select_row",
		    GTK_SIGNAL_FUNC(prefs_applet_list_clicked),NULL);
    gtk_container_add(GTK_CONTAINER(prefs_applet_skined_scr),
		    prefs_applet_skined_list);

    gtk_notebook_append_page(GTK_NOTEBOOK(prefs_notebook),
	prefs_applet_frame, gtk_label_new("Applet"));

#ifndef USE_PANEL
    gtk_widget_set_sensitive(prefs_applet_frame, FALSE);
#endif

    /* OK, Cancel, Apply */

    prefs_bbox = gtk_hbutton_box_new();
    gtk_button_box_set_layout(GTK_BUTTON_BOX(prefs_bbox),GTK_BUTTONBOX_END);
    gtk_button_box_set_spacing(GTK_BUTTON_BOX(prefs_bbox),5);
        gtk_box_pack_start(GTK_BOX(prefs_vbox),prefs_bbox,FALSE,FALSE,0);
#ifdef USE_GNOME
    prefs_ok = gnome_stock_button(GNOME_STOCK_BUTTON_OK);
#else
    prefs_ok = gtk_button_new_with_label("Ok");
#endif
    GTK_WIDGET_SET_FLAGS(prefs_ok, GTK_CAN_DEFAULT);
    gtk_window_set_default(GTK_WINDOW(prefs_win), prefs_ok);
    gtk_signal_connect(GTK_OBJECT(prefs_ok),"clicked",
				GTK_SIGNAL_FUNC(prefs_ok_cb),NULL);
    GTK_WIDGET_SET_FLAGS(prefs_ok,GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(prefs_bbox),prefs_ok,TRUE,TRUE,0);
#ifdef USE_GNOME
    prefs_apply = gnome_stock_button(GNOME_STOCK_BUTTON_APPLY);
#else
    prefs_apply = gtk_button_new_with_label("Apply");
#endif
    gtk_signal_connect(GTK_OBJECT(prefs_apply),"clicked",
				GTK_SIGNAL_FUNC(prefs_apply_cb),NULL);
    GTK_WIDGET_SET_FLAGS(prefs_apply,GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(prefs_bbox),prefs_apply,TRUE,TRUE,0);
#ifdef USE_GNOME
    prefs_cancel = gnome_stock_button(GNOME_STOCK_BUTTON_CANCEL);
#else
    prefs_cancel = gtk_button_new_with_label("Cancel");
#endif
    gtk_signal_connect(GTK_OBJECT(prefs_cancel),"clicked",
				GTK_SIGNAL_FUNC(prefs_cancel_cb),NULL);
    GTK_WIDGET_SET_FLAGS(prefs_cancel,GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(prefs_bbox),prefs_cancel,TRUE,TRUE,0);
}

void show_preferences ()
{
    char text[7], *row[2];
    struct channel *chan;
    int i;

    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_alarm_startup), config->alarm_on);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_timer_startup), config->timer_on);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_volume_startup), config->set_volume);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_plugins_startup), config->load_plugins);
    snprintf(text, 3, "%u", config->def_volume);
    gtk_entry_set_text (GTK_ENTRY(prefs_gen_volume_val), text);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_channel_startup),config->set_channel);
    snprintf(text, 3, "%u", config->def_channel);
    gtk_entry_set_text (GTK_ENTRY(prefs_gen_channel_val), text);
    snprintf(text, 3, "%u", config->fft_style);
    gtk_entry_set_text (GTK_ENTRY(prefs_gen_fft_val), text);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
		(prefs_gen_verbose), config->verbose_messages);
#ifdef USE_PANEL
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
		(prefs_gen_start_hidden), config->start_hidden);
#endif

    if (config->layout_file)
	gtk_entry_set_text (GTK_ENTRY(prefs_layout_file), config->layout_file);
    else
	gtk_entry_set_text (GTK_ENTRY(prefs_layout_file), "");

    switch (config->quit_mute)
    {
    case 0: gtk_toggle_button_set_active(
			    GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_no), TRUE);
	    break;
    case 1: gtk_toggle_button_set_active(
			    GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_yes), TRUE);
	    break;
    case 2: gtk_toggle_button_set_active(
			    GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_ask), TRUE);
	    break;
    }

    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
			(prefs_gen_exit_save), config->save_on_exit);
    for (i=0; i<7; i++)
    {
	Alarm.hour[i] = config->alarm.hour[i];
	Alarm.minute[i] = config->alarm.minute[i];
	Alarm.station[i] = config->alarm.station[i];
    }
    Alarm.day_bitmask = config->alarm.day_bitmask;

    {
        time_t t;
        struct tm *tm;
        int today;
	char val[5];

        time(&t);
        tm = localtime(&t);
        today = tm->tm_wday;
	last_day = today;

        gtk_option_menu_set_history (GTK_OPTION_MENU(prefs_alarm_days),today);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (prefs_alarm_active),
				config->alarm.day_bitmask & (1 << today));
	snprintf(val, 4, "%i", config->alarm.hour[today]);
	gtk_entry_set_text (GTK_ENTRY(prefs_alarm_hour_v), val);
	snprintf(val, 4, "%i", config->alarm.minute[today]);
	gtk_entry_set_text (GTK_ENTRY(prefs_alarm_min_v), val);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prefs_alarm_station_use),
					config->alarm.station[today] != -1);
	if (config->alarm.station[today] != -1)
	{
	    snprintf(val, 4, "%i", config->alarm.station[today]);
	    gtk_entry_set_text (GTK_ENTRY(prefs_alarm_station_v), val);
	}
	else
	    gtk_entry_set_text (GTK_ENTRY(prefs_alarm_station_v), "");
    }

    snprintf(text, 3, "%u", config->sleep.sleep_time);
    gtk_entry_set_text (GTK_ENTRY(prefs_timer_val), text);

    gtk_clist_clear (GTK_CLIST(prefs_stations_list));

    for (i=0; i<config->num_channels; i++)
    {
	chan = get_channel(config->first_channel, i);
	if (chan)
	{
	    row[0] = chan->name;
	    row[1] = malloc(10);
	    snprintf(row[1], 9, "%3.2f", chan->frequency);
	    gtk_clist_append(GTK_CLIST(prefs_stations_list), row);
	    free(row[1]);
	}
    }

    snprintf(text, 6, "0x%x", config->card_port);
    gtk_entry_set_text (GTK_ENTRY(prefs_cards_port_val), text);

    gtk_widget_set_sensitive(prefs_stations_add,0);
    gtk_widget_set_sensitive(prefs_stations_delete,0);
    gtk_widget_set_sensitive(prefs_stations_chg,0);
    gtk_widget_set_sensitive(prefs_stations_listen,0);
    gtk_widget_set_sensitive(prefs_stations_curr,0);
    gtk_entry_set_text (GTK_ENTRY(prefs_stations_chan_edit), "");
    gtk_entry_set_text (GTK_ENTRY(prefs_stations_freq_edit), "");

    plugins_list_refresh();

#ifdef USE_PANEL
    current_applet_style = config->panel_applet_style;
    switch(config->panel_applet_style)
    {
    case PANEL_STYLE_NONE:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_none),TRUE);
	break;
    case PANEL_STYLE_OFF:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_off),TRUE);
	break;
    case PANEL_STYLE_TEXT:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_text),TRUE);
	break;
    case PANEL_STYLE_CHAN_BUTS:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_buts),TRUE);
	break;
    case PANEL_STYLE_THEMED:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_skined),TRUE);
	break;
    default:
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(prefs_applet_style_none),TRUE);
	break;
    }
    gtk_clist_clear (GTK_CLIST(prefs_applet_skined_list));
    gtk_entry_set_text(GTK_ENTRY(prefs_applet_skined_dir),
		    config->applet_skin_path);
    {
	char *applet_skin_path =
		gnome_unconditional_datadir_file(PACKAGE "/applet_skins");
	DIR *dp;
	struct dirent *dir;
	struct stat ent_sbuf;

	if((dp = opendir(applet_skin_path))==NULL)
	{
	    printf("gtuner: skin directory not found: %s\n", applet_skin_path);
	    g_free(applet_skin_path);
	} else
	{
	    while ((dir = readdir(dp)) != NULL)
	    {
		gchar *name;
		gchar *path;

		name = dir->d_name;
		path = g_strconcat(applet_skin_path, "/", name, NULL);

		if (stat(path,&ent_sbuf) >= 0 && S_ISDIR(ent_sbuf.st_mode))
		{
		    if ((strcmp(name, ".")!=0)&&(strcmp(name, "..")!=0))
		    {
			gchar *themedata_file = g_strconcat(path, "/theme.data", NULL);
			if (g_file_exists(themedata_file))
			{
			    int n_row;
			    row[0] = name;
			    if (prefs_applet_skindir)
				    g_free(prefs_applet_skindir);
			    prefs_applet_skindir = g_strdup(path);
			    n_row = gtk_clist_append(GTK_CLIST(prefs_applet_skined_list),row);
			    gtk_clist_set_row_data_full(GTK_CLIST(prefs_applet_skined_list),
					    n_row, prefs_applet_skindir, (GtkDestroyNotify) g_free);
			}
			g_free(themedata_file);
		    }
		}
		g_free(path);
	    }
	    closedir(dp);
	}
    }
#endif
    gtk_widget_show_all(prefs_win);
}

static
void prefs_apply_changes()
{
    int i, count;
    char *text[2], *val;
    double f;
    int g;
    struct channel *ch, *first, *curr;

/* General tag */

    config->alarm_on = GTK_TOGGLE_BUTTON
			(prefs_gen_alarm_startup)->active;
    config->timer_on = GTK_TOGGLE_BUTTON
			(prefs_gen_timer_startup)->active;
    config->set_volume = GTK_TOGGLE_BUTTON
			(prefs_gen_volume_startup)->active;
    config->load_plugins = GTK_TOGGLE_BUTTON
			(prefs_gen_plugins_startup)->active;
    config->verbose_messages = GTK_TOGGLE_BUTTON
			(prefs_gen_verbose)->active;
#ifdef USE_PANEL
    config->start_hidden = GTK_TOGGLE_BUTTON
			(prefs_gen_start_hidden)->active;
#endif

    val = gtk_entry_get_text (GTK_ENTRY(prefs_gen_volume_val));
    if (sscanf(val, "%i", &g) != 1)
    {
	printf("gtuner: entry in the volume box is not a valid number\n");
    } else
    {
        if ((g < 0) || (g > GLOBAL_MAX_VOL))
        {
	    printf("gtuner: volume out of range\n");
        } else
	    config->def_volume = g;
    }
    config->set_channel = GTK_TOGGLE_BUTTON
			(prefs_gen_channel_startup)->active;

    val = gtk_entry_get_text (GTK_ENTRY(prefs_gen_channel_val));
    if (sscanf(val, "%i", &g) != 1)
    {    
	printf("gtuner: entry in the channel box is not a valid number\n");
    } else
    {
	if ((g < 0) || (g > GLOBAL_MAX_VOL))
	{
	    printf("gtuner: channel out of range\n");
	} else
	    config->def_channel = g;
    }

    val = gtk_entry_get_text (GTK_ENTRY(prefs_gen_fft_val));
    if (strcmp(val, "0")==0)
	config->fft_style = 0;
    else
    if (strcmp(val, "1")==0)
        config->fft_style = 1;
    else
	printf("gtuner: invalid fft_style\n");

    config->layout_file = gtk_entry_get_text (GTK_ENTRY(prefs_layout_file));

    if (GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_no)->active)
	    config->quit_mute = 0;
    if (GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_yes)->active)
	    config->quit_mute = 1;
    if (GTK_TOGGLE_BUTTON (prefs_gen_exit_mute_ask)->active)
	    config->quit_mute = 2;

    config->alarm_on = GTK_TOGGLE_BUTTON
			(prefs_gen_exit_save)->active;

/* Cron tag */

    prefs_alarm_callback(NULL,(char*)(1 << last_day));
    for (i=0; i<7; i++)
    {
	config->alarm.hour[i] = Alarm.hour[i];
	config->alarm.minute[i] = Alarm.minute[i];
	config->alarm.station[i] = Alarm.station[i];
    }
    config->alarm.day_bitmask = Alarm.day_bitmask;

    val = gtk_entry_get_text (GTK_ENTRY(prefs_timer_val));
    if (sscanf(val, "%i", &g) != 1)
    {
	printf("gtuner: entry in the timer box is not a valid number\n");
    } else
    {
	config->sleep.sleep_time = g;
    }

/* Stations tag */

    first = ch = curr = NULL;
    count = 0;

    for (i=0; i<GTK_CLIST(prefs_stations_list)->rows; i++)
    {
	gtk_clist_get_text (GTK_CLIST(prefs_stations_list),
			i, 0, &text[0]);
	if (!text[0])
	    continue;
	gtk_clist_get_text (GTK_CLIST(prefs_stations_list),
			i, 1, &text[1]);
	if (text[1])
	{
	    if (sscanf(text[1], "%lf", &f)!=1)
		continue;
	}
	else
	    continue;

	if (!first)
	{
	    first = new_channel(f, text[0], count);
	    curr = first;
	}
	else
	{
	    ch = new_channel(f, text[0], count);
	    insert_channel(curr, ch);
	    curr = curr->next;
	}
	count++;
    }
    if (config->first_channel)
    {
	while (config->first_channel->next)
	    remove_channel(config->first_channel->next);
	remove_channel(config->first_channel);
    }

    config->num_channels = count;
    config->first_channel = first;

    popups_reset_stations();
    callback_set_freq (NULL, card_get_frequency ());

    for (i=1; i<g_slist_length(channel_list); i++)
    {
	GSList *entry = g_slist_nth(channel_list, i);
	if (entry == NULL) continue;
	CH_BUTS_REFRESH(entry, config->first_channel);
    }

    /* Cards */

    val = gtk_entry_get_text (GTK_ENTRY(prefs_cards_port_val));
    if (sscanf(val, "%x", &g) != 1)
    {
	printf("gtuner: entry in the volume box is not a valid number\n");
    } else
    {
        if (g < 0)
        {
	    printf("gtuner: port setting out of range\n");
        } else
	    config->card_port = g;
    }

    if (new_card)
    if (new_card != get_current_card())
    {
	set_current_card(new_card, config->card_port);
	config->card_name = new_card->filename;
    }

    for (i=1; i<g_slist_length(freq_bar_list); i++)
    {
	GSList *entry = g_slist_nth(freq_bar_list, i);
	if (entry->data == NULL) continue;

	FREQ_BAR_UPDATE(entry);
	FREQ_BAR_SET(entry, card_get_frequency());
    }

#ifdef USE_PANEL
    /* Applet */

    val = gtk_entry_get_text(GTK_ENTRY(prefs_applet_skined_dir));
    if (g_file_exists(val))
    {
	config->applet_skin_path = val;
    } else
	printf("gtuner: specified applet skin path does not exist\n");

    if (GTK_TOGGLE_BUTTON (prefs_applet_style_none)->active)
	                config->panel_applet_style = PANEL_STYLE_NONE;
    if (GTK_TOGGLE_BUTTON (prefs_applet_style_off)->active)
	                config->panel_applet_style = PANEL_STYLE_OFF;
    if (GTK_TOGGLE_BUTTON (prefs_applet_style_text)->active)
	                config->panel_applet_style = PANEL_STYLE_TEXT;
    if (GTK_TOGGLE_BUTTON (prefs_applet_style_buts)->active)
	                config->panel_applet_style = PANEL_STYLE_CHAN_BUTS;
    if (GTK_TOGGLE_BUTTON (prefs_applet_style_skined)->active)
	                config->panel_applet_style = PANEL_STYLE_THEMED;

    if (config->panel_applet_style != current_applet_style)
    {
	applet_set_style(config->panel_applet_style);
	current_applet_style = config->panel_applet_style;
    }
#endif

    gtk_widget_grab_default(prefs_ok);
}
