/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* hardware.h */
#ifndef HARDWARE_H
#define HARDWARE_H

#include "plugins/plugins.h"
#include "channel.h"
#include <glib.h>

struct CardPluginData
{
    GList	*card_list;
    CardPlugin	*current_card_plugin;
    int channel;
    gboolean muted;
    gboolean card_on;
    gboolean stereo;
};

GList *get_card_list();
CardPlugin *get_current_card();
void set_current_card(CardPlugin*, int port);
void card_on  ();
void card_off ();
void card_mute ();
void card_unmute ();
void card_inc_volume ();
void card_dec_volume ();
void card_set_volume (int);
int  card_get_volume ();
void card_set_frequency  (double);
double card_get_frequency ();
void card_tune_up ();
void card_tune_down ();
void card_set_stereo (gboolean);
gboolean  card_is_tuned ();
gboolean  card_is_stereo ();
double card_get_frequency_step ();
double card_get_max_frequency ();
double card_get_min_frequency ();
void card_about(int card);
void card_configure(int card);
void card_cleanup();
void card_set_channel(struct channel* chan);

void initialize_cards();

#endif /*HARDWARE_H*/
