/* gtuner
	Copyright (c) 1998-1999 Carl van Schaik (carl@leg.uct.ac.za)
	cRadio, kTuner, gtuner (c) 1998-1999 Carl van Schaik

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "sleep.h"
#include "conf.h"
#include "callbacks.h"
#include "gui/popup_menu.h"
#include <gtk/gtkmain.h>

gint sleep_interupt;

static int timeout_sleep_timer(struct radio_config *conf)
{
    int i;
    callback_mute(NULL, NULL);

#ifdef USE_GNOME
    gtk_check_menu_item_set_active(timer_item, FALSE);
#else
    GTK_CHECK_MENU_ITEM(gtk_item_factory_get_widget(
			popup_menu,"/Sleep Timer"))->active = FALSE;
#endif
    for (i=1; i<g_slist_length(display_list); i++)
    {
	GSList *entry = g_slist_nth(display_list, i);
	if (entry->data == NULL) continue;

	DISP_SET_TIMER(entry, FALSE, conf->sleep.sleep_time);
    }

    sleep_interupt = 0;
    return FALSE;
}

void initialize_timer(struct radio_config *conf)
{
    sleep_interupt = 0;
    if(!conf->timer_on)
	return;
    conf->sleep.active = TRUE;
    sleep_interupt = gtk_timeout_add(conf->sleep.sleep_time*1000*60,
				(GtkFunction)timeout_sleep_timer, conf);
}

void activate_timer(struct radio_config *conf)
{
    int i;

    if(conf->sleep.active)
        return;
    conf->sleep.active = TRUE;
    sleep_interupt = gtk_timeout_add(conf->sleep.sleep_time*1000*60,
				(GtkFunction)timeout_sleep_timer, conf);

#ifdef USE_GNOME
    gtk_check_menu_item_set_active(timer_item, TRUE);
#else
    GTK_CHECK_MENU_ITEM(gtk_item_factory_get_widget(
			popup_menu,"/Sleep Timer"))->active = TRUE;
#endif
    for (i=1; i<g_slist_length(display_list); i++)
    {
        GSList *entry = g_slist_nth(display_list, i);
        if (entry->data == NULL) continue;

        DISP_SET_TIMER(entry, TRUE, conf->sleep.sleep_time);
    }
}

void deactivate_timer(struct radio_config *conf)
{
    int i;

    conf->sleep.active = FALSE;
    if (sleep_interupt)
	gtk_timeout_remove(sleep_interupt);
    sleep_interupt = 0;

#ifdef USE_GNOME
    gtk_check_menu_item_set_active(timer_item, FALSE);
#else
    GTK_CHECK_MENU_ITEM(gtk_item_factory_get_widget(
			popup_menu,"/Sleep Timer"))->active = FALSE;
#endif
    for (i=1; i<g_slist_length(display_list); i++)
    {
	GSList *entry = g_slist_nth(display_list, i);
	if (entry->data == NULL) continue;

	DISP_SET_TIMER(entry, FALSE, conf->sleep.sleep_time);
    }
}
